MODULE IOTest;

FROM AESForms IMPORT FormAlert;
FROM BIOS IMPORT BPBPtr, GetBPB, RWAbs;
FROM GEMDOS IMPORT Alloc, Free;
FROM SYSTEM IMPORT ADDRESS;
FROM SystemTimer IMPORT StartTimer, StopTimer, ElapsedTime, 
                        KillTimer, timerhandle;
FROM InOut IMPORT WriteString, WriteLn, Write, Read;
FROM LongInOut IMPORT WriteLongCard;
IMPORT BIOS;

VAR  Device : CARDINAL;
     bpb    : BPBPtr;
     Buffer : ADDRESS;
     Bufsiz : LONGCARD;
     String : ARRAY [0..80] OF CHAR;
     Result : LONGINT;
     Done : BOOLEAN;
     Button : INTEGER;
     ch : CHAR;
     timerid: timerhandle;
     time : LONGCARD;

PROCEDURE InitBuffer;

BEGIN
     Alloc(0FFFFFFFFH,Buffer);      (* Set up copy buffer *)
     Bufsiz:=LONGCARD(Buffer);  
     IF (Bufsiz < LONG(100*1024)) THEN
       String := "[3][Insufficient Memory][OK]";
       Button := FormAlert(1,String);
       Done := FALSE;
       RETURN;
     END;
     Alloc(Bufsiz,Buffer);
     IF ( Buffer = 0 ) THEN
       String := "[3][Unable to Allocate Memory][OK]";
       Button := FormAlert(1,String);
       Done := FALSE;
       RETURN;
     END ;
END InitBuffer;


BEGIN

InitBuffer;

LOOP

  WriteLn;
  WriteString("Measure disk IO transfer rate."); WriteLn;
  WriteString("Enter drive number to test (A --> P): ");
  Read(ch); Write(ch); WriteLn;
  ch:=CAP(ch);
  IF (ch< "A") OR (ch>"P") THEN EXIT; END;
  Device:=ORD(ch)-ORD("A");
  (* Force media change if needed *)
  bpb:=GetBPB(Device);
  (* Pre-seek drive head *)
  Result:=RWAbs(BIOS.ReadNoMediaChange,Buffer,1,18,Device);
  IF Result<0 THEN
    WriteString("Read error.");
    WriteLn;
    EXIT;
  END;
  StartTimer(timerid);
  Result:=RWAbs(BIOS.ReadNoMediaChange,Buffer,200,18,Device);
  StopTimer(timerid);
  IF Result<0 THEN
    WriteString("Read error.");
    WriteLn;
    EXIT;
  END;
  time:=ElapsedTime(timerid);
  KillTimer(timerid);
  WriteString("Elapsed time = "); WriteLongCard(time,8); WriteLn;
  WriteLongCard((LONG(200 * 200) * 512 DIV time ),8);
  WriteString(" Bytes per second."); WriteLn; WriteLn;
  ch:="N";
  WriteString("Again? (Y/[N]) ");
  Read(ch); Write(ch); WriteLn; WriteLn;
  IF CAP(ch)#"Y" THEN EXIT; END;

END; (* Loop *);

Done:=Free(Buffer);

END IOTest.

